/**********
Copyright 1990 Regents of the University of California.  All rights reserved.
Author: 1985 Thomas L. Quarles
**********/
/*
 */

/* Pretty print the sensitivity info for all 
 * the diodes in the circuit.
 */

#include "ngspice.h"
#include <stdio.h>
#include "smpdefs.h"
#include "cktdefs.h"
#include "diodefs.h"
#include "sperror.h"
#include "suffix.h"


void
DIOsPrint(inModel,ckt)
    GENmodel *inModel;
    CKTcircuit *ckt;
{
    DIOmodel *model = (DIOmodel*)inModel;
    DIOinstance *here;

    printf("DIOS-----------------\n");
    /*  loop through all the diode models */
    for( ; model != NULL; model = model->DIOnextModel ) {

        printf("Model name:%s\n",model->DIOmodName);

        /* loop through all the instances of the model */
        for (here = model->DIOinstances; here != NULL ;
                here=here->DIOnextInstance) {
	    if (here->DIOowner != ARCHme) continue;

            printf("    Instance name:%s\n",here->DIOname);
            printf("      Positive, negative nodes: %s, %s\n",
            CKTnodName(ckt,here->DIOposNode),CKTnodName(ckt,here->DIOnegNode));
            printf("      Area: %g ",here->DIOarea);
            printf(here->DIOareaGiven ? "(specified)\n" : "(default)\n");
            printf("    DIOsenParmNo:%d\n",here->DIOsenParmNo);

        }
    }
}
